<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::composite_gate&lt; T, U &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classdlib_1_1composite__gate-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::composite_gate&lt; T, U &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::composite_gate&lt; T, U &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1composite__gate.png" usemap="#dlib::composite_5Fgate_3C_20T_2C_20U_20_3E_map" alt=""/>
  <map id="dlib::composite_5Fgate_3C_20T_2C_20U_20_3E_map" name="dlib::composite_5Fgate_3C_20T_2C_20U_20_3E_map">
<area href="classdlib_1_1gate__exp.html" alt="dlib::gate_exp&lt; composite_gate&lt; T, U &gt; &gt;" shape="rect" coords="0,0,248,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:ada315bb3de7dd5ddb2b8f8f4ec7cfb1b"><td class="memItemLeft" align="right" valign="top"><a id="ada315bb3de7dd5ddb2b8f8f4ec7cfb1b"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>lhs_type</b></td></tr>
<tr class="separator:ada315bb3de7dd5ddb2b8f8f4ec7cfb1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d56ee9fa8de5613874acf06d3859ef7"><td class="memItemLeft" align="right" valign="top"><a id="a0d56ee9fa8de5613874acf06d3859ef7"></a>
typedef U&#160;</td><td class="memItemRight" valign="bottom"><b>rhs_type</b></td></tr>
<tr class="separator:a0d56ee9fa8de5613874acf06d3859ef7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a3e07c49b89fad732639986613c4253c8"><td class="memItemLeft" align="right" valign="top"><a id="a3e07c49b89fad732639986613c4253c8"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>composite_gate</b> (const <a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a> &amp;g)</td></tr>
<tr class="separator:a3e07c49b89fad732639986613c4253c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2deff33dbafa046c33441eb2ce19ab54"><td class="memItemLeft" align="right" valign="top"><a id="a2deff33dbafa046c33441eb2ce19ab54"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>composite_gate</b> (const <a class="el" href="classdlib_1_1gate__exp.html">gate_exp</a>&lt; T &gt; &amp;lhs_, const <a class="el" href="classdlib_1_1gate__exp.html">gate_exp</a>&lt; U &gt; &amp;rhs_)</td></tr>
<tr class="separator:a2deff33dbafa046c33441eb2ce19ab54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4319ddc6cb6399a78ba1078a6a5f8bc4"><td class="memItemLeft" align="right" valign="top"><a id="a4319ddc6cb6399a78ba1078a6a5f8bc4"></a>
const qc_scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>operator()</b> (long r, long c) const</td></tr>
<tr class="separator:a4319ddc6cb6399a78ba1078a6a5f8bc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a992a92b004a5bf3427022fe4937dd85c"><td class="memTemplParams" colspan="2"><a id="a992a92b004a5bf3427022fe4937dd85c"></a>
template&lt;typename exp &gt; </td></tr>
<tr class="memitem:a992a92b004a5bf3427022fe4937dd85c"><td class="memTemplItemLeft" align="right" valign="top">qc_scalar_type&#160;</td><td class="memTemplItemRight" valign="bottom"><b>compute_state_element</b> (const <a class="el" href="classdlib_1_1matrix__exp.html">matrix_exp</a>&lt; exp &gt; &amp;reg, long row_idx) const</td></tr>
<tr class="separator:a992a92b004a5bf3427022fe4937dd85c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1gate__exp"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1gate__exp')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classdlib_1_1gate__exp.html">dlib::gate_exp&lt; composite_gate&lt; T, U &gt; &gt;</a></td></tr>
<tr class="memitem:ae29287d727467b077fd9041e6581ffa8 inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="ae29287d727467b077fd9041e6581ffa8"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>gate_exp</b> (<a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a>&lt; T, U &gt; &amp;exp_)</td></tr>
<tr class="separator:ae29287d727467b077fd9041e6581ffa8 inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cfd6484826164ccef411dedbafe9763 inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a3cfd6484826164ccef411dedbafe9763"></a>
const qc_scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>operator()</b> (long r, long c) const</td></tr>
<tr class="separator:a3cfd6484826164ccef411dedbafe9763 inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9cbb00e017a4817888ba366787a47f6 inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="aa9cbb00e017a4817888ba366787a47f6"></a>
const <a class="el" href="classdlib_1_1matrix.html">matrix</a>&lt; qc_scalar_type &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>mat</b> () const</td></tr>
<tr class="separator:aa9cbb00e017a4817888ba366787a47f6 inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a510f9075a5cfb1beb904984de33191cf inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a510f9075a5cfb1beb904984de33191cf"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>apply_gate_to</b> (<a class="el" href="classdlib_1_1quantum__register.html">quantum_register</a> &amp;reg) const</td></tr>
<tr class="separator:a510f9075a5cfb1beb904984de33191cf inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0322a19e97605fefc0cb3ca8dd097baf inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a0322a19e97605fefc0cb3ca8dd097baf"></a>
qc_scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>compute_state_element</b> (const <a class="el" href="classdlib_1_1matrix__exp.html">matrix_exp</a>&lt; exp &gt; &amp;reg, long row_idx) const</td></tr>
<tr class="separator:a0322a19e97605fefc0cb3ca8dd097baf inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63de49e8e7338cfc5ea8a85d3cc75399 inherit pub_methods_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a63de49e8e7338cfc5ea8a85d3cc75399"></a>
const <a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a>&lt; T, U &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>ref</b> () const</td></tr>
<tr class="separator:a63de49e8e7338cfc5ea8a85d3cc75399 inherit pub_methods_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:afbedf7fb22ab195a1fd61cb99dd63a9d"><td class="memItemLeft" align="right" valign="top"><a id="afbedf7fb22ab195a1fd61cb99dd63a9d"></a>
const T&#160;</td><td class="memItemRight" valign="bottom"><b>lhs</b></td></tr>
<tr class="separator:afbedf7fb22ab195a1fd61cb99dd63a9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96c584f0038cf1cbad7b87264c0c6629"><td class="memItemLeft" align="right" valign="top"><a id="a96c584f0038cf1cbad7b87264c0c6629"></a>
const U&#160;</td><td class="memItemRight" valign="bottom"><b>rhs</b></td></tr>
<tr class="separator:a96c584f0038cf1cbad7b87264c0c6629"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a70b875c28705230d3aadfe3469b5d896"><td class="memItemLeft" align="right" valign="top"><a id="a70b875c28705230d3aadfe3469b5d896"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>num_bits</b> = <a class="el" href="structdlib_1_1gate__traits.html">gate_traits</a>&lt;<a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a>&gt;::num_bits</td></tr>
<tr class="separator:a70b875c28705230d3aadfe3469b5d896"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e094f5f886f2d754e1290d324d114b2"><td class="memItemLeft" align="right" valign="top"><a id="a0e094f5f886f2d754e1290d324d114b2"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>dims</b> = <a class="el" href="structdlib_1_1gate__traits.html">gate_traits</a>&lt;<a class="el" href="classdlib_1_1composite__gate.html">composite_gate</a>&gt;::dims</td></tr>
<tr class="separator:a0e094f5f886f2d754e1290d324d114b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_attribs_classdlib_1_1gate__exp"><td colspan="2" onclick="javascript:toggleInherit('pub_static_attribs_classdlib_1_1gate__exp')"><img src="closed.png" alt="-"/>&#160;Static Public Attributes inherited from <a class="el" href="classdlib_1_1gate__exp.html">dlib::gate_exp&lt; composite_gate&lt; T, U &gt; &gt;</a></td></tr>
<tr class="memitem:a9d77602a883a39dde10cb2843651fd9f inherit pub_static_attribs_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a9d77602a883a39dde10cb2843651fd9f"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>num_bits</b></td></tr>
<tr class="separator:a9d77602a883a39dde10cb2843651fd9f inherit pub_static_attribs_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a986edc81a42217a69e24680c45b2a043 inherit pub_static_attribs_classdlib_1_1gate__exp"><td class="memItemLeft" align="right" valign="top"><a id="a986edc81a42217a69e24680c45b2a043"></a>
static const long&#160;</td><td class="memItemRight" valign="bottom"><b>dims</b></td></tr>
<tr class="separator:a986edc81a42217a69e24680c45b2a043 inherit pub_static_attribs_classdlib_1_1gate__exp"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="quantum__computing_2quantum__computing_8h_source.html">quantum_computing/quantum_computing.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
